#include "motor_control.h"
#include "tb6612_motor_driver/tb6612_motor_driver.h"

static void motor_control_task(void * params);

static int32_t speed;

void motor_control_task_init(void)
{
   tb6612_init();
   tb6612_standby_high();

	rtos_task_create(motor_control_task, "motor", MOTOR_STACKSIZE,
			MOTOR_PRIORITY);
}

void motor_speed_set(int32_t val)
{
	if (val > 100)
	{
		val = 100;
	}
	else if (val < -100)
	{
		val = -100;
	}

	if (val >= 0)
	{
		tb6612_motor_1_forward();
		tb6612_motor_1_speed_set(val);
	}
	else
	{
		tb6612_motor_1_forward();
		tb6612_motor_1_speed_set(-val);
	}

	speed = val;
}

int32_t motor_speed_get(void)
{
	return speed;
}

static void motor_control_task(void * params)
{
   (void) params;

   rtos_delay(100);

   while(1)
   {
	   rtos_delay(10);
   }
}
