#include "encoder.h"

#include "gpio_f4/gpio_f4.h"

#define ENC_A_PIN	4
#define ENC_B_PIN	5

static void gpio_init(void)
{
	RCC->AHB1ENR |= RCC_AHB1ENR_GPIOBEN;

	gpio_mode_config(GPIOB, ENC_A_PIN, GPIO_MODE_AF);
	gpio_mode_config(GPIOB, ENC_B_PIN, GPIO_MODE_AF);

	gpio_af_config(GPIOB, ENC_A_PIN, GPIO_AF_TIM3);
	gpio_af_config(GPIOB, ENC_B_PIN, GPIO_AF_TIM3);
}

static void timer_init(void)
{
	RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;

	/* Set timer to encoder mode */
	TIM3->SMCR = TIM_SMCR_SMS_0 | TIM_SMCR_SMS_1;
	/* Set timer inputs mapped on TI1 and TI2 */
	TIM3->CCMR1 = TIM_CCMR1_CC1S_0 | TIM_CCMR1_CC2S_1;
	/* Set auto reload value to max */
	TIM3->ARR = 0xFFFF;

	TIM3->CR1 = TIM_CR1_CEN;
}

void encoder_init(void)
{
	gpio_init();
	timer_init();
}

int32_t encoder_read(void)
{
	int32_t val;
	val = TIM3->CNT;
	TIM3->CNT = 0;
	return val;
}
