#ifndef TB6612_H_
#define TB6612_H_

#include "platform_specific.h"

/**
 * @brief TB6612 motor driver initialization.
 */
void tb6612_init(void);

/**
 * @brief Set motor 1 speed.
 *
 * @param speed							Motor speed, possible values 0-100.
 */
void tb6612_motor_1_speed_set(int32_t speed);

/**
 * @brief Set standby bit low.
 *
 * This turns off motor driver.
 */
void tb6612_standby_low(void);

/**
 * @brief Set standby bit high.
 *
 * This turns on motor driver.
 */
void tb6612_standby_high(void);

/**
 * @brief Set motor 1 direction to forward.
 */
void tb6612_motor_1_forward(void);

/**
 * @brief Set motor 1 direction to backward.
 */
void tb6612_motor_1_backward(void);

/**
 * @brief Stop motor 1.
 */
void tb6612_motor_1_stop(void);

#endif /* TB6612_H_ */
